%     AERO LOAD - программа для нагружения агрегатов самолета распределенной нагрузкой
%     Copyright (C) 2018-2024  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Distribution = Access_User_Model(Z, Load)

User_Model = Load.Chord_Pressure.User_Model_Data;

if (Z == User_Model.Span_Coord(1,1))
    
    Distribution = User_Model.Pressure_Data{1};
    return;
    
end

if (Z < User_Model.Span_Coord(1,1))
    
    switch Load.Extrapolation.User_Model_0
        
        case 'CONSTANT'
            
            Distribution = User_Model.Pressure_Data{1};
            return;
            
        case 'LINEAR'
            
            if (size(User_Model.Span_Coord,1) == 1)
                
                Distribution = User_Model.Pressure_Data{1};
                return;
                
            else
                
                Distr_1 = User_Model.Pressure_Data{1};
                Distr_2 = User_Model.Pressure_Data{2};

                Common_Domain = Union_Column(Distr_1(:,1), Distr_2(:,1));

                Distribution = zeros(size(Common_Domain,1),2);
                Distribution(:,1) = Common_Domain;

                k_1 = (User_Model.Span_Coord(2,1) - Z) / (User_Model.Span_Coord(2,1) - User_Model.Span_Coord(1,1));
                k_2 = (Z - User_Model.Span_Coord(1,1)) / (User_Model.Span_Coord(2,1) - User_Model.Span_Coord(1,1));

                for j=1:size(Distribution,1)

                    Value_1 = Access_Array(Distr_1, Distribution(j,1), Load.Extrapolation.Chord_Pressure_0, Load.Extrapolation.Chord_Pressure_1);
                    Value_2 = Access_Array(Distr_2, Distribution(j,1), Load.Extrapolation.Chord_Pressure_0, Load.Extrapolation.Chord_Pressure_1);

                    Distribution(j,2) = k_1 * Value_1 + k_2 * Value_2;

                end
                
                return;
                
            end
            
        case 'ZERO_VALUE'
            
            Distribution = [0,0;1,0];
            return;
        
    end
    
end

if (Z == User_Model.Span_Coord(size(User_Model.Span_Coord,1),1))
    
    Distribution = User_Model.Pressure_Data{size(User_Model.Pressure_Data,1)};
    return;
    
end

if (Z > User_Model.Span_Coord(size(User_Model.Span_Coord,1),1))
    
    switch Load.Extrapolation.User_Model_1
        
        case 'CONSTANT'
            
            Distribution = User_Model.Pressure_Data{size(User_Model.Pressure_Data,1)};
            return;
            
        case 'LINEAR'
            
            if (size(User_Model.Span_Coord,1) == 1)
                
                Distribution = User_Model.Pressure_Data{size(User_Model.Pressure_Data,1)};
                return;
                
            else
                
                Distr_1 = User_Model.Pressure_Data{size(User_Model.Pressure_Data,1)-1};
                Distr_2 = User_Model.Pressure_Data{size(User_Model.Pressure_Data,1)};

                Common_Domain = Union_Column(Distr_1(:,1), Distr_2(:,1));

                Distribution = zeros(size(Common_Domain,1),2);
                Distribution(:,1) = Common_Domain;

                k_1 = (User_Model.Span_Coord(size(User_Model.Span_Coord,1),1) - Z) / (User_Model.Span_Coord(size(User_Model.Span_Coord,1),1) - User_Model.Span_Coord(size(User_Model.Span_Coord,1)-1,1));
                k_2 = (Z - User_Model.Span_Coord(size(User_Model.Span_Coord,1)-1,1)) / (User_Model.Span_Coord(size(User_Model.Span_Coord,1),1) - User_Model.Span_Coord(size(User_Model.Span_Coord,1)-1,1));

                for j=1:size(Distribution,1)

                    Value_1 = Access_Array(Distr_1, Distribution(j,1), Load.Extrapolation.Chord_Pressure_0, Load.Extrapolation.Chord_Pressure_1);
                    Value_2 = Access_Array(Distr_2, Distribution(j,1), Load.Extrapolation.Chord_Pressure_0, Load.Extrapolation.Chord_Pressure_1);

                    Distribution(j,2) = k_1 * Value_1 + k_2 * Value_2;

                end
                
                return;
                
            end
            
        case 'ZERO_VALUE'
            
            Distribution = [0,0;1,0];
            return;
        
    end
    
end

for i=1:size(User_Model.Span_Coord,1)-1
    
    if ((Z >= User_Model.Span_Coord(i,1)) && (Z <= User_Model.Span_Coord(i+1,1)))
        
        Distr_1 = User_Model.Pressure_Data{i};
        Distr_2 = User_Model.Pressure_Data{i+1};
        
        Common_Domain = Union_Column(Distr_1(:,1), Distr_2(:,1));
        
        Distribution = zeros(size(Common_Domain,1),2);
        Distribution(:,1) = Common_Domain;
        
        k_1 = (User_Model.Span_Coord(i+1,1) - Z) / (User_Model.Span_Coord(i+1,1) - User_Model.Span_Coord(i,1));
        k_2 = (Z - User_Model.Span_Coord(i,1)) / (User_Model.Span_Coord(i+1,1) - User_Model.Span_Coord(i,1));
        
        for j=1:size(Distribution,1)

            Value_1 = Access_Array(Distr_1, Distribution(j,1), Load.Extrapolation.Chord_Pressure_0, Load.Extrapolation.Chord_Pressure_1);
            Value_2 = Access_Array(Distr_2, Distribution(j,1), Load.Extrapolation.Chord_Pressure_0, Load.Extrapolation.Chord_Pressure_1);

            Distribution(j,2) = k_1 * Value_1 + k_2 * Value_2;

        end
        
        break;
        
    end
    
end
